﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace RoboRace
{
    public partial class VisualField : Panel
    {
        // směr Leraka nebo null
        public char? Smer;

        // směr Leraka nebo null
        public char? MoznySmer;

        // směr Leraka nebo null
        public char? CestaSmer;

        public VisualField()
        {
            InitializeComponent();
        }

        public bool IsActivated
        {
            get { return label1.BackColor == Color.LightSkyBlue; }
            set { label1.BackColor = value ? Color.LightSkyBlue : SystemColors.Control; }
        }

        public void SetText(string value)
        {
            this.label1.Text = value;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Brush brush;
            Point[] points = null;

            base.OnPaint(e);
            if (Smer.HasValue)
            {
                brush = new SolidBrush(Color.FromArgb(128, 255, 0, 0));

                switch (Smer.Value)
                {
                    case 'N':
                        points = new Point[] {
                            new Point(Width / 2, 0),
                            new Point(0, Height),
                            new Point(Width, Height)
                        };
                        break;
                    case 'R':
                        points = new Point[] {
                            new Point(0, 0),
                            new Point(Width, Height / 2),
                            new Point(0, Height)
                        };
                        break;
                    case 'D':
                        points = new Point[] {
                            new Point(0, 0),
                            new Point(Width, 0),
                            new Point(Width / 2, Height)
                        };
                        break;
                    case 'L':
                        points = new Point[] {
                            new Point(Width, 0),
                            new Point(0, Height / 2),
                            new Point(Width, Height)
                        };
                        break;
                }

                e.Graphics.FillPolygon(brush, points);
            }

            if (MoznySmer.HasValue)
            {
                brush = new SolidBrush(Color.FromArgb(128, 0, 0, 255));

                switch (MoznySmer.Value)
                {
                    case 'N':
                        points = new Point[] {
                            new Point(Width / 2, 0),
                            new Point(0, Height),
                            new Point(Width, Height)
                        };
                        break;
                    case 'R':
                        points = new Point[] {
                            new Point(0, 0),
                            new Point(Width, Height / 2),
                            new Point(0, Height)
                        };
                        break;
                    case 'D':
                        points = new Point[] {
                            new Point(0, 0),
                            new Point(Width, 0),
                            new Point(Width / 2, Height)
                        };
                        break;
                    case 'L':
                        points = new Point[] {
                            new Point(Width, 0),
                            new Point(0, Height / 2),
                            new Point(Width, Height)
                        };
                        break;
                }

                e.Graphics.FillPolygon(brush, points);
            }

            if (CestaSmer.HasValue)
            {
                brush = new SolidBrush(Color.FromArgb(128, 0, 255, 0));

                switch (CestaSmer.Value)
                {
                    case 'N':
                        points = new Point[] {
                            new Point(Width / 2, 0),
                            new Point(0, Height),
                            new Point(Width, Height)
                        };
                        break;
                    case 'R':
                        points = new Point[] {
                            new Point(0, 0),
                            new Point(Width, Height / 2),
                            new Point(0, Height)
                        };
                        break;
                    case 'D':
                        points = new Point[] {
                            new Point(0, 0),
                            new Point(Width, 0),
                            new Point(Width / 2, Height)
                        };
                        break;
                    case 'L':
                        points = new Point[] {
                            new Point(Width, 0),
                            new Point(0, Height / 2),
                            new Point(Width, Height)
                        };
                        break;
                }

                e.Graphics.FillPolygon(brush, points);
            }
        }
    }
}
